;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Dragon Coin
;
;When Extra Bit is set, the sprite has different property depending on intial X position
;If initil X position is even, the sprite can be eaten by Yoshi, otherwise, the sprite will go behind of stuff.
;When Extra Bit is clear, the sprite is just a dragon coin as a sprite.
;
;
;This sprite considers Item Memory (or whatever you call it), so you can place this sprites
;like you do with a dragon coin of the obeject, and it acts like the object.
;(meaning that, the coin at the same position won't appear again after collected.)
;
;
;Extra Bits : 
;Clear
;	: normal Dragon Coin
;Set
;X0	: Can be eaten by Yoshi
;X1	: Is behind of stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

incsrc xkas_def.asm

!TopTile		= $88
!BottomTile		= $A8


			incsrc definition.asm

			print "INIT ",pc
Init:			PHX
			LDA $14E0,x
			STA $151C,x
			LDA $14D4,x
			STA $1528,x
			LDA $E4,x
			STA $1534,x

			JSR GetXandY
			LDA $1F2F,y
			AND $05B35B,x
			BNE .Kill
			JSR GetItemMemoryPtr
			LDA ($08),y
			AND $0DA8A6,x
			BNE .Kill
			PLX
			LDA $7FAB10,x
			AND #$04
			BEQ .R
			LDA $E4,x
			AND #$10
			BNE .Behind
			DEC $1686,x
			RTL
.Behind			INC $1632,x
.R			RTL
.Kill			PLX
			STZ $14C8,x
			RTL

			print "MAIN ",pc
			JSR SpriteMain
			JSR SpriteGraphic
			RTL


GetItemMemoryPtr:	LDX $13BE
			LDA #$F8
			CLC
			ADC $0DA8AE,x
			STA $08
			LDA #$19
			ADC $0DA8B1,x
			STA $09

			LDX $15E9
			LDA $1534,x
			LSR #$04
			STA $02

			LDA $5B
			LSR A
			BCS .VertLevel
			LDA $151C,x
			STA $00
			LDA $1528,x
			BRA .Get
.VertLevel		LDA $1528,x
			STA $00
			LDA $151C,x

.Get			STA $01

			LDA $00
			ASL #$02
			LSR $01
			BCC $02
			ORA #$02
			TAY
			LDA $02
			AND #$08
			BEQ $01
			INY
			LDA $02
			AND #$07
			TAX
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteMain:		LDA $9D
			BNE .R
			LDA $14C8,x
			CMP #$07
			BNE .NotEaten
			STZ $18AC
			BRA .Interacted

.NotEaten		CMP #$08
			BNE .R
			JSL !SubOffScreen
			JSL $81A7DC
			BCC .R
.Interacted		PHX

			LDA #$01
			JSL $85B330	;lets Mario get a coin

			LDA $7F
			ORA $81
			BNE .NoTwinkle
			LDY #$03
.FindSlot		LDA $17C0,y
			BEQ .Twinkle
			DEY
			BPL .FindSlot
			BRA .NoTwinkle
.Twinkle		LDA #$05
			STA $17C0,y
			LDA $E4,x
			AND #$F0
			STA $17C8,y
			LDA $D8,x
			AND #$F0
			STA $17C4,y
			LDA #$10
			STA $17CC,y

.NoTwinkle
			JSR GetItemMemoryPtr
			LDA ($08),y
			ORA $0DA8A6,x
			STA ($08),y

			JSL $80F377	;show point depending on the number of current dragon coins Mario has.
			INC $1422
			LDA $1422
			CMP #$05
			BCC .NotCollected5

			JSR GetXandY
			LDA $05B35B,x
			ORA $1F2F,y
			STA $1F2F,y

.NotCollected5		LDA #$1C
			STA $1DF9

			PLX
			STZ $14C8,x
.R			RTS

GetXandY:		LDA $13BF
			LSR #$03
			TAY
			LDA $13BF
			AND #$07
			TAX
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteGraphic:		JSR !GetDrawInfo

			LDA $00
			STA $0300,y
			STA $0304,y

			LDA $01
			DEC A
			STA $0301,y
			CLC
			ADC #$10
			STA $0305,y

			LDA #!TopTile
			STA $0302,y
			LDA #!BottomTile
			STA $0306,y

			LDA $1632,x
			LSR A
			LDA $15F6,x
			BCS $02
			ORA $64
			STA $0303,y
			STA $0307,y

			LDY #$02
			LDA #$01
			JSL $81B7B3
			RTS
