;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Hoopster, from SMB2 (or USA)
;
;Extra Bit: No
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Extra Property 1
;0 - can be killed by spin jump
;1 - can be carried
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc definition.asm

TileMap			db $80,$82
Property		db $0D,$8D
Property2		= $8D			;please set same value as second byte of Property

Yspeed			db $08,$FA,$16,$F0	;2 bytes each, slow/fast

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			db "INIT"
			LDA $96
			CMP $D8,x
			LDA $97
			SBC $14D4,x
			BPL InitReturn
			INC $157C,x
InitReturn		RTL

			db "MAIN"
			PHB
			PHK
			PLB
			CMP #$09
			BCS IsCarried
			JSR SpriteMain
			PLB
			RTL
IsCarried		LDA $9D
			BNE IsCarried2
			INC $1570,x
IsCarried2		PHX
			LDY $15EA,x
			LDA $1570,x
			LSR A
			LSR A
			AND #$01
			TAX
			LDA TileMap,x
			STA $0302,y
			LDA $0303,y
			AND #$30
			ORA #Property2
			STA $0303,y
			PLX
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteMain		JSR SpriteGraphic

			LDA $9D
			BNE Return
			INC $1570,x
			LDA $14C8,x
			CMP #$08
			BNE Return
			JSR SubOffScreen

			LDY $157C,x
			LDA $94
			SEC
			SBC $E4,x
			CLC
			ADC #$18
			CMP #$30
			BCS NotNearMario
			LDA #$01
			STA $1504,x
			INY
			INY
NotNearMario		LDA Yspeed,y
			STA $AA,x
			JSL $81801A
			JSL $819138
			LDA $185F
			CMP #$25
			BNE CheckGroundStatus
			LDA $18D7
			BEQ ChangeDir
CheckGroundStatus	LDA $1588,x
			BEQ Interact
ChangeDir		JSR ChangeDirection
Interact		LDY #$B9
			LDA $1490
			BNE DefaultInteraction
			LDA $7FAB28,x
			AND #$01
			AND $140D
			BEQ StoreTo167A
DefaultInteraction	LDY #$39
StoreTo167A		TYA	
			STA $167A,x
			JSL $81803A
			BCC Return
			LDA $14C8,x
			CMP #$08
			BNE Return
			PHK
			PER.w #$0007
			PEA $8020
			JML $81B45C
Return			RTS
			BCC SpriteWins
			LDA $7FAB28,x
			AND #$02
			BEQ MarioWins
			BIT $16
			BVC MarioWins
			LDA #$0B
			STA $14C8,x
			STZ $1540,x
			LDA #$99
			STA $167A,x
			LDA #$80
			STA $1686,x
			RTS
MarioWins		LDA #$08
			STA $154C,x
			RTS
SpriteWins		LDA $154C,x
			BNE MarioGndStatus
			JSL $80F5B7
			RTS
MarioGndStatus		LDA $77
			AND #$08
			BEQ Return
			LDA $1540,x
			BNE Return
			LDA #$04
			STA $1540,x
ChangeDirection		LDA $157C,x
			EOR #$01
			STA $157C,x
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite's Graphic
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteGraphic		JSR GetDrawInfo

			LDA $1504,x
			PHP
			LDA $1570,x
			LSR A
			LSR A
			PLP
			BNE Graphic000
			LSR A
Graphic000		AND #$01
			STA $03
			LDA $157C,x
			STA $02

			PHX
			LDA $00
			STA $0300,y
			LDA $01
			STA $0301,y
			LDX $03
			LDA TileMap,x
			STA $0302,y
			LDX $02
			LDA Property,x
			ORA $64
			STA $0303,y
			PLX
			LDY #$02
			LDA #$00
			JSL $81B7B3
			RTS